

#include "lcd_ctl.h"


// short delay for lcd
void delay(int ticks)
{
    while(ticks--);
}

// lcd strobe
void lcd_pulse(void)
{
    lcd_set_e();
    delay(4);
    lcd_clear_e();
    delay(4);
}

// medium delay (long for lcd, but much less than a second)
void lcd_wait(void)
{
    delay(1000);
}

// send byte to lcd
void lcd_send(unsigned char data)
{
    lcd_wait();
	outp( data, PORTA );
    lcd_pulse();
}

// clear screen
void clrscr(void)
{
    lcd_clear_rs();
    lcd_clear_rw();
    lcd_send(0x01);
    lcd_wait();
}

// init display
void init_lcd(void)
{
	outp( 0xFF, DDRA );
	sbi(DDRC, 0);
	sbi(DDRC, 1);
	sbi(DDRC, 2);

    lcd_clear_rs();  // RS=RW=0 ̸ instruction set mode
    lcd_clear_rw();
    lcd_send(0x3C);  // 0011 1100
                     // 4 : 8Ʈ 
					 // 32 = 1X : 2Line 5*7Font
    lcd_send(0x3C);
    lcd_send(0x3C);
    lcd_send(0x06);  // 0000 0110
	                 // 1 : 巹 1 Ű,
					 // Ŀ Ǵ ũ  ̵Ѵ.
					 // 0 : ǥô Ʈ  ʴ´.
    lcd_send(0x0C);  // 0000 1100
	                 // 2 : ǥø ONѴ.
					 // 1 : Ŀ ǥ ʴ´.
					 // 0 : Ŀġ ϴ ڸ  ʴ´.
    clrscr();
}

// goto lcd memory address
void gotoz(unsigned char z)
{
    lcd_clear_rs();
    lcd_clear_rw();
    lcd_send(z | 0x80);
}

// output single character
void putchar(char c)
{
    lcd_clear_rw();  // RS=1, RW=0 ̸ ͸ ִ´.
    lcd_set_rs();
    lcd_send(c);
}

// output string
void outtext(char* text)
{
    unsigned char i;
    for(i = 0; text[i] && i < 8; i++)
    putchar(text[i]);
}

void gotoxy(int x, int y)
{
	if (y <2 )
		gotoz((x)|((y)<<6));
	else 
	{
		y = y -2;
		gotoz((x)|(((y) << 6 ) | 20) );
	}
}

